----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:08:58 01/22/2012 
-- Design Name: 
-- Module Name:    3dglasses - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;


---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

--The Vectrex will adjust the PWM: longer negative, more speed
--The target of the Vectrex is to get the index pulse frequency at about 27Hz.

entity glasses3d is
--The pos values are in range 0-179, with the amount of degrees as index. 180-360 are 'black'.
	generic (
		--Please fill in some actual values on instantiation.
		pos_green: integer :=0;
		pos_red: integer :=60;
		pos_blue: integer :=90;
		pos_index: integer :=0
   );
    Port ( 
			  clk : in  STD_LOGIC; --12MHz please
           reset : in  STD_LOGIC;
           pwm_in : in  STD_LOGIC;
           sync_out : out  STD_LOGIC;
           rgb_out : out  STD_LOGIC_VECTOR (2 downto 0);
           shutter_out : out  STD_LOGIC
);
end glasses3d;

architecture Behavioral of glasses3d is
	signal pos: STD_LOGIC_VECTOR(7 downto 0);
	signal speed: STD_LOGIC_VECTOR(11 downto 0);
	signal speedNew: STD_LOGIC_VECTOR(20 downto 0);
	signal speedCnt: STD_LOGIC_VECTOR(11 downto 0);
	signal pwmCnt: STD_LOGIC_VECTOR(18 downto 0);
	signal pwmNeg: STD_LOGIC_VECTOR(18 downto 0);
	signal pwmNegOld: STD_LOGIC_VECTOR(19 downto 0);
	signal lrsel: STD_LOGIC;
begin
	imager: process(clk)
		variable tgtSpeed: std_logic_vector(11 downto 0);
		variable cnt : integer := -1;
	begin
		if reset='1' then
			speed<=conv_std_logic_vector(1600, 12);
			speedNew<=conv_std_logic_vector(1600, 12)&"000000000";
--			speed<=(others => '1'); --start slow
			speedCnt<=(others => '0');
			lrsel<='0';
			sync_out<='0';
			rgb_out<="000";
		elsif rising_edge(clk) then
			cnt:=cnt+1;
			if cnt=4 then
				cnt:=0;
				pwmCnt<=pwmCnt+"1";
				--pwmCnt is 19bit, gaat dus 'af' met 25Hz -> plm 1 frame
				if (pwmCnt="00000000000000000000") then
					-- pwmNeg(19 downto 8): range 0-4K
					-- Eventually is about .37 of the time negative -> pwmNeg is 1529
					-- Speed should be about 1230 when pwmNeg(19 downto 6) is 1529 for a 27Hz signal
					if unsigned(pwmNeg)>unsigned(conv_std_logic_vector(120000, 20)) then
						--Speed up, move to quickest speed rapidly
						tgtSpeed:=conv_std_logic_vector(1, 12);
					elsif unsigned(pwmNeg)<unsigned(conv_std_logic_vector(1000, 20)) then
						--Idle, go to lowest speed
						tgtSpeed:=conv_std_logic_vector(3000, 12);
					else
						tgtSpeed:=(conv_std_logic_vector((1529+1230), 12)-pwmNeg(18 downto 7));
						--tgtSpeed:=conv_std_logic_vector(1290,12);
					end if;
--					tgtSpeed:=conv_std_logic_vector(1195,12);
					speedNew<=(speed&"000000000")-("000000000"&speed)+("000000000"&tgtSpeed);
					pwmNeg<=(others => '0');
				else
					if pwm_in='0' then
						pwmNeg<=pwmNeg+conv_std_logic_vector(1, 20);
					end if;
				end if;
			end if;
			
			speedCnt<=speedCnt+"1";
			if speedCnt=speed then
				speedCnt<=(others => '0');
				if unsigned(speedNew(20 downto 9))<unsigned(speed) then
					--Increase of speed. Just copypaste.
					speed<=speedNew(20 downto 9);
				elsif unsigned(speedNew(20 downto 9))>unsigned(speed) then
					--Decrease of speed. Decrease just a bit.
					speed<=speed+"000000000001";
				end if;

				if pos=conv_std_logic_vector(179, 8) then
					--We made half a turn!
					pos<=(others => '0');
					lrsel<=not lrsel;
				else
					pos<=pos+"00000001";
				end if;

				if pos=conv_std_logic_vector(pos_red, 8) then
					rgb_out<="001";
				elsif pos=conv_std_logic_vector(pos_green, 8) then
					rgb_out<="010";
				elsif pos=conv_std_logic_vector(pos_blue, 8) then
					rgb_out<="100";
				end if;
				
				if lrsel='0' then
					if pos=conv_std_logic_vector(pos_index, 8) then
						sync_out<='0';
					elsif pos=(conv_std_logic_vector(pos_index, 8)+conv_std_logic_vector(5, 8)) then
						sync_out<='1';
					end if;
				else
					sync_out<='1';
				end if;
			end if;
		end if;
	end process;
	shutter_out<=lrsel;
end Behavioral;

