library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SPRITE_PWM is
    Port ( clk      	: in  STD_LOGIC;
           pwmvalue 	: in  STD_LOGIC_VECTOR (7 downto 0);
           pwm_stb  	: in std_logic;
           pwmout_h   	: out STD_LOGIC := '0';
           pwmout_l   	: out STD_LOGIC := '0');
end SPRITE_PWM;



architecture Behavioral of SPRITE_PWM is
signal val_int_h: STD_LOGIC_VECTOR(3 downto 0);
signal count_h: STD_LOGIC_VECTOR(3 downto 0);
signal val_int_l: STD_LOGIC_VECTOR(3 downto 0);
signal count_l: STD_LOGIC_VECTOR(3 downto 0);
begin

pwm_h: process(clk)
begin
--	if reset='1' then
--		pwmout_h<='0';
--		count<="0000";
	if rising_edge(clk) then
		count_h<=count_h+"0001";
		if count_h<val_int_h then
			pwmout_h<='0';
		else
			pwmout_h<='1';
		end if;
		if count_h="0000" then
			val_int_h<=pwmvalue(7 downto 4);
		end if;
	end if;
end process;

pwm_l: process(clk)
begin
--	if reset='1' then
--		output<='0';
--		count<="0000";
	if rising_edge(clk) then
		count_l<=count_l+"0001";
		if count_l<val_int_l then
			pwmout_l<='0';
		else
			pwmout_l<='1';
		end if;
		if count_l="0000" then
			val_int_l<=pwmvalue(3 downto 0);
		end if;
	end if;
end process;

end Behavioral;


--architecture Behavioral of SPRITE_PWM is
--
--signal cnt_h : integer range 0 to 15 := 0;
--signal cnt_l : integer range 0 to 15 := 0;
--signal pwmvalue_h : std_logic_vector (3 downto 0);
--signal pwmvalue_l : std_logic_vector (3 downto 0);
--
--begin
--   
--	load_cnt : process (clk)
--    begin
--        if rising_edge(clk) then
--			--if pwm_stb = '1' then
--				pwmvalue_h(3) <= pwmvalue(7);
--				pwmvalue_h(2) <= pwmvalue(6);
--				pwmvalue_h(1) <= pwmvalue(5);
--				pwmvalue_h(0) <= pwmvalue(4);
--				pwmvalue_l(3) <= pwmvalue(3);
--				pwmvalue_l(2) <= pwmvalue(2);
--				pwmvalue_l(1) <= pwmvalue(1);
--				pwmvalue_l(0) <= pwmvalue(0);
--			--end if;
--		end if;
--	end process;
--
--   my_cnth : process
--   begin
--      wait until rising_edge(clk);      
--		if (cnt_h<15) then cnt_h <= cnt_h+1;
--		else               cnt_h <= 0;
--      end if;      
--  end process;
--  
--   my_cntl : process
--   begin
--      wait until rising_edge(clk);       
--		if (cnt_l<15) then cnt_l <= cnt_l+1;
--		else               cnt_l <= 0;
--      end if;      
--  end process;
--   
--   pwmout_h <= '0' when (cnt_h>=to_integer(unsigned(pwmvalue_h))) else '1';
--   pwmout_l <= '0' when (cnt_l>=to_integer(unsigned(pwmvalue_l))) else '1'; 
--end Behavioral;